package de.korap.services;

import java.util.List;

import javax.xml.bind.annotation.XmlAccessorType;
//import javax.xml.bind.annotation.XmlRootElement;
//import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.*;

/* General infos:
 * http://blog.bdoughan.com/2011/06/using-jaxbs-xmlaccessortype-to.html
 */

/*
 * LemmaResponse: 
 * Object to return by GlemmServices on a Lemma Request.
 * Will be converted by glassfish to JSON.
 * Notes:
 * - header fields are prexided by 'head_' because JSON will be sorted alphabetically by JAXB.
 * 
 * 24.01.20/FB
 */

//@XmlRootElement(name="LemmaResponse") - no effect
@XmlAccessorType(XmlAccessType.PUBLIC_MEMBER)
//@XmlType (name="abc", propOrder={"query", "options", "nWfs", "listofWfs"}) - no effect


public class LemmaResponse 

{
	final int PRINT_LIST_LIMIT	= 10; // do not print more than 10 Wfs of listofWfs[].
	
	public int
		head_nWfs = 0;
	public String
		head_query   = null,
		head_options = null, // e.g. "+flex-sonst",
		head_errMess = null;
			
	public List<String>
		listofWfs = null;
	
	public LemmaResponse()
	{
		
	}
	
	/* toString
	 * - formats partially a LemmaResponse obj to string.
	 * Returns formated string or null if an error occures.
	 * 29.04.20/FB
	 */
	
	public String toString()
	
	{
	String
		s = null;
	//StringBuffer
	//	sb = new StringBuffer();
	
	s = String.format("head: nWfs=%d, list=%s.", this.head_nWfs, this.listofWfs);
	
	return s != null ? s : "";
	} // toString

	/*   printPartialList:
	 * 
	 * - prints the full list of Wfs or, if the list is longer than 
	 *   PRINT_LIST_LIMIT, only the beginning and the end of it.
	 * 
	 * Returns the formated (partial) list of Wfs as a string or "[]" if
	 *         the list is empty.
	 * 27.10.21/FB
	 */
	
	public String printPartialList()
	
	{
	StringBuffer
		sb = new StringBuffer();
	final int
		iMin = PRINT_LIST_LIMIT/2,
		iMax = this.listofWfs.size()-(PRINT_LIST_LIMIT/2);
	
	sb.append('[');
	
	for(int i=0; i<this.listofWfs.size(); i++)
		{
		if( i<iMin || i>=iMax )
			{
			if(i>0)
				sb.append(',');
			sb.append(this.listofWfs.get(i));
			}
		}
	sb.append(']');
	
	return sb.toString();
	
	} // printPartialList

}
